<?php
    
    namespace frontend\controllers;
    
    use common\models\Articles;
    use common\models\ArticlesSearch;
    use yii\web\Controller;
    use yii\web\NotFoundHttpException;
    
    /**
     * Article controller
     */
    class ArticleController extends Controller
    {
        
        /**
         * Displays article list.
         * @return string
         */
        public function actionIndex()
        {
            $searchModel = new ArticlesSearch();
            $dataProvider = $searchModel->search(\Yii::$app->request->queryParams);
            $dataProvider->query->orderBy([ 'date' => SORT_DESC ]);
            $dataProvider->pagination = [
                'pageSize' => 10,
            ];
            
            return $this->render('index', [
                'searchModel'  => $searchModel,
                'dataProvider' => $dataProvider,
            ]);
        }
        
        /**
         * Display one article page.
         * @return string
         */
        public function actionView($id)
        {
            $model = $this->findModel($id);
            return $this->render('view', [
                'model' => $model,
            ]);
        }
        
        private function findModel($id)
        {
            $model = Articles::find()
                             ->where([ 'articles_id' => $id ])
                             ->joinWith('lang', true, 'INNER JOIN')
                             ->one();
            if(!empty( $model )) {
                return $model;
            } else {
                throw new NotFoundHttpException();
            }
        }
    }
